"use strict";
/*
 * MIT License
 *
 * Copyright (c) 2018 Choko (choko@curioswitch.org)
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
}
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
}
Object.defineProperty(exports, "__esModule", { value: true });
require("@babel/polyfill");
const history_1 = require("history");
const react_1 = __importDefault(require("react"));
const react_dom_1 = __importDefault(require("react-dom"));
const react_redux_1 = require("react-redux");
const react_router_redux_1 = require("react-router-redux");
const styled_components_1 = require("styled-components");
const LanguageProvider_1 = __importDefault(require("../containers/LanguageProvider"));
const init_1 = __importDefault(require("../i18n/init"));
const init_2 = __importDefault(require("../redux/init"));
function render(messages, store, history, mountNode, Component, theme) {
    react_dom_1.default.render(<react_redux_1.Provider store={store}>
      <LanguageProvider_1.default messages={messages}>
        <styled_components_1.ThemeProvider theme={theme || {}}>
          <react_router_redux_1.ConnectedRouter history={history}>
            <Component />
          </react_router_redux_1.ConnectedRouter>
        </styled_components_1.ThemeProvider>
      </LanguageProvider_1.default>
    </react_redux_1.Provider>, mountNode);
}
function init(config) {
    const history = history_1.createBrowserHistory();
    const store = init_2.default(config.initialState, history);
    const mountNode = config.mountNode
        ? typeof config.mountNode === 'string'
            ? document.getElementById(config.mountNode)
            : config.mountNode
        : document.getElementById('app');
    const formattedMessages = init_1.default(config.defaultLocale, config.messages);
    const doRender = (component) => render(formattedMessages, store, history, mountNode, component, config.theme || {});
    if (!window.Intl) {
        Promise.resolve().then(() => __importStar(require('intl'))).then(() => Promise.resolve().then(() => __importStar(require('intl/locale-data/jsonp/en.js'))))
            .then(() => doRender(config.component))
            .catch((err) => {
            throw err;
        });
    }
    else {
        doRender(config.component);
    }
    return (component) => {
        react_dom_1.default.unmountComponentAtNode(mountNode);
        doRender(component);
    };
}
exports.default = init;
//# sourceMappingURL=init.jsx.map