/// <reference types="react" />
/// <reference types="react-redux" />
/**
 *
 * LanguageProvider
 *
 * this component connects the redux state language locale to the
 * IntlProvider component and i18n messages (loaded from `app/translations`)
 */
import React from 'react';
export interface Messages {
    [key: string]: string;
}
export interface LocaleMessages {
    [locale: string]: Messages;
}
export interface Props {
    locale: string;
    messages: LocaleMessages;
}
export declare class LanguageProvider extends React.PureComponent<Props> {
    render(): JSX.Element;
}
declare const _default: React.ComponentClass<Pick<Props, "messages">> & {
    WrappedComponent: React.ComponentType<Props>;
};
export default _default;
