"use strict";
/*
 * MIT License
 *
 * Copyright (c) 2018 Choko (choko@curioswitch.org)
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
Object.defineProperty(exports, "__esModule", { value: true });
const history_1 = require("history");
const immutable_1 = require("immutable");
const react_router_redux_1 = require("react-router-redux");
const redux_immutable_1 = require("redux-immutable");
exports.routeInitialState = immutable_1.Record({
    location: history_1.createLocation(''),
})();
function routeReducer(state, action) {
    switch (action.type) {
        case react_router_redux_1.LOCATION_CHANGE:
            return state.set('location', action.payload);
        default:
            return state;
    }
}
exports.routeReducer = routeReducer;
function createInitalReducer(identityReducers, nonInjectedReducers) {
    return redux_immutable_1.combineReducers({
        ...identityReducers,
        ...nonInjectedReducers,
    });
}
exports.createInitalReducer = createInitalReducer;
function createReducer(store) {
    return redux_immutable_1.combineReducers({
        ...store.identityReducers,
        ...store.injectedReducers,
        ...store.nonInjectedReducers,
    });
}
exports.default = createReducer;
//# sourceMappingURL=reducers.js.map